clc
clear all
close all
%% Load input values
% parentpath = cd(cd('..'));
% %load(fullfile(parentpath,'R.mat')) %ENDRES ETTER BEHOV
% load(fullfile(parentpath,'Rtest3.mat')) %ENDRES ETTER BEHOV
% R=Rtest3;
% load(fullfile(parentpath,'S.mat'))
load('SimulationResults_400000.mat','SPAR')
check=isfinite(SPAR);
R=SPAR(check);

% load('461517.mat');
load('S.mat');
%R=nonzeros(SPAR);

Nsim=min(length(R),length(S));
R=R(1:Nsim); S=S(1:Nsim)';
R_middel=mean(R); S_middel=mean(S);

%% 

figure
subplot(2,1,1)
histfit(R,ceil(sqrt(Nsim)),'normal')
xlim([20 180])
ylabel('R')
subplot(2,1,2)
histfit(S,ceil(sqrt(Nsim)),'gev')
ylabel('S')
xlim([20 180])
% M=R-S;
% pf=sum(M<0)/Nsim
% cov_pf=sqrt((1-pf)/(Nsim*pf))
% conf_pf=[1-1.96*cov_pf 1+1.96*cov_pf]*pf
%%
lambda_v=linspace(0.2,0.4,70);
M_N = Nsim;
L=linspace(0.4,1,100000);
x1=lambda_v(1);
%%
M=R-S;
M = M(1:M_N);
 figure(3)
 histfit(M)
 ylabel('M')
%%
pf0=sum(M<0)/Nsim
% cov_pf=sqrt((1-pf0)/(Nsim*pf0))
% conf_pf=[1-1.96*cov_pf 1+1.96*cov_pf]*pf0
M_middel=mean(M)

pf_lambda = zeros(1,length(lambda_v));
Cv_pf_lambda = zeros(1,length(lambda_v));
CI_p_lambda = zeros(1,length(lambda_v));
CI_m_lambda = zeros(1,length(lambda_v));
Mlammin=0;
for nn=1:length(lambda_v)
    lambda=lambda_v(1,nn);

    M_lambda=M-M_middel*(1-lambda);
    Mlammin(nn)=min(M_lambda);
    pf_lambda(1,nn)=sum(M_lambda<0)/Nsim;
    Cv_pf_lambda(1,nn)=sqrt((1-pf_lambda(1,nn))/(pf_lambda(1,nn)*Nsim));
    CI_p_lambda(1,nn) = pf_lambda(1,nn).*(1+1.96.*Cv_pf_lambda(1,nn));
    CI_m_lambda(1,nn) = pf_lambda(1,nn).*(1-1.96.*Cv_pf_lambda(1,nn));
end
%
%%
power_weights=2;
W_lambda = (log(CI_p_lambda)-log(CI_m_lambda)).^(-power_weights);
%%
% Checking for all weights to be "positive" and "real"
pos_index = W_lambda>0;
real_index = imag(W_lambda)~=0; 
if ~isempty(pos_index)
    %fprintf('Non-positive weights of the objective function changed to positive.\n')
    W_lambda = abs(W_lambda); 
elseif ~isempty(real_index)
    %fprintf('Imaginary weights of the objective function changed to real.\n')
    W_lambda = abs(W_lambda); 
end
% Normalizing weights to have sum(w)=1
W_lambda = W_lambda/sum(W_lambda);
clear pos_index real_index;
%%
b0 = 0.2; c0 = 2;
[r, slope, intersept] = regression((lambda_v-b0).^c0,log(pf_lambda)); 
% y = a*x + b linear regression(x,y) ; log(q*(b,c))=y_+a*(b,c)x_ , y=log(pf(L)) , x=(L-b)^c

figure(12)
plot((lambda_v-b0).^c0,log(pf_lambda))
a0 = abs(slope); q0 = exp(intersept);
X0 = [q0 a0 b0 c0];                        % Starting guess
%%
optst_logLM_all = optimset('Display','final',...
     'Algorithm', 'levenberg-marquardt', ...
     'MaxFunEvals', 10000,...
     'MaxIter', 10000,...
     'TolX', 1e-15,...
     'TolFun', 1e-12);
[X,resnorm] = lsqnonlin(@myfun,X0,[],[],optst_logLM_all,pf_lambda,lambda_v,W_lambda);
% X = [0.180 14.943 0.152 1.2825];

pf1=X(1).*exp(-X(2).*(L-X(3)).^X(4));
pfX0=X0(1).*exp(-X0(2).*(lambda_v-X0(3)).^X0(4));

pf1_L1=X(1).*exp(-X(2).*(1-X(3)).^X(4));

figure(10)
semilogy(lambda_v,pfX0,'--k',L,pf1,'g','Linewidth',2)
%% Reanchoring  
pf1_reanch=X(1).*exp(-X(2).*(lambda_v-X(3)).^X(4));
Cv_pf_lambda_reanch = zeros(1,length(lambda_v));
CI_p_lambda_reanch = zeros(1,length(lambda_v));
CI_m_lambda_reanch = zeros(1,length(lambda_v));
for nn=1:length(lambda_v)
    lambda=lambda_v(1,nn);
    Cv_pf_lambda_reanch(1,nn)=sqrt((1-pf1_reanch(1,nn))/(pf1_reanch(1,nn)*Nsim));
    CI_p_lambda_reanch(1,nn) = pf1_reanch(1,nn).*(1+1.96.*Cv_pf_lambda_reanch(1,nn));
    CI_m_lambda_reanch(1,nn) = pf1_reanch(1,nn).*(1-1.96.*Cv_pf_lambda_reanch(1,nn));
end
%% fit cI minus
b0_m = 0.2; c0_m = 2;
[r_m slope_m intersept_m] = regression((lambda_v-b0_m).^c0_m,log(CI_m_lambda_reanch)); % y = a*x + b linear regression(x,y) ; log(q*(b,c))=y_+a*(b,c)x_ , y=log(pf(L)) , x=(L-b)^c
% figure(14)
% plot((lambda_v-b0_m).^c0_m,log(CI_m_lambda_reanch))
a0_m = abs(slope_m); q0_m = exp(intersept_m);
X0_m = [q0_m a0_m b0_m c0_m];                        % Starting guess

optst_logLM_all_m = optimset('Display','final',...
     'Algorithm', 'levenberg-marquardt', ...
     'MaxFunEvals', 100000,...
     'MaxIter', 100000,...
     'TolX', 1e-15,...
     'TolFun', 1e-12);
[X_m,resnorm_m] = lsqnonlin(@myfun,X0_m,[],[],optst_logLM_all_m,CI_m_lambda_reanch,lambda_v,W_lambda);

% L=linspace(0.4,1,100);
CI_m_lambda_reanch_m=X_m(1).*exp(-X_m(2).*(L-X_m(3)).^X_m(4));
% pfX0=X0(1).*exp(-X0(2).*(lambda_v-X0(3)).^X0(4));

CI_m_lambda_reanch_L1_m=X_m(1).*exp(-X_m(2).*(1-X_m(3)).^X_m(4));

 figure(11)
 semilogy(lambda_v,CI_m_lambda_reanch,'--k',L,CI_m_lambda_reanch_m,'r','Linewidth',2)
% [fin_sol_pl, fmin_pl, pos_pl, sol_pl] = Optimization(bar_lev, ...
%     CI_plus_reanch, eta_1, W, q0_pl, b0_pl, a0_pl, c0_pl, qMedian_pl, bmin);
%% fit cI plus
b0_p = 0.2; c0_p = 2;
[r_p slope_p intersept_p] = regression((lambda_v-b0_p).^c0_p,log(CI_p_lambda_reanch)); % y = a*x + b linear regression(x,y) ; log(q*(b,c))=y_+a*(b,c)x_ , y=log(pf(L)) , x=(L-b)^c
% figure(14)
% plot((lambda_v-b0_p).^c0_p,log(CI_p_lambda_reanch))
a0_p = abs(slope_p); q0_p = exp(intersept_p);
X0_p = [q0_p a0_p b0_p c0_p] ;                       % Starting guess

optst_logLM_all_p = optimset('Display','final',...
     'Algorithm', 'levenberg-marquardt', ...
     'MaxFunEvals', 100000,...
     'MaxIter', 100000,...
     'TolX', 1e-15,...
     'TolFun', 1e-12);
[X_p,resnorm_p] = lsqnonlin(@myfun,X0_p,[],[],optst_logLM_all_p,CI_p_lambda_reanch,lambda_v,W_lambda);

% L=linspace(0.4,1,1000);
CI_p_lambda_reanch_p=X_p(1).*exp(-X_p(2).*(L-X_p(3)).^X_p(4));
% pfX0=X0(1).*exp(-X0(2).*(lambda_v-X0(3)).^X0(4));

CI_p_lambda_reanch_L1_p=X_p(1).*exp(-X_p(2).*(1-X_p(3)).^X_p(4));

% figure(11)
% semilogy(lambda_v,CI_p_lambda_reanch,'--k',L,CI_p_lambda_reanch_p,'r','Linewidth',2)
%%
% % epsilon = @(eta,x) x(1)*exp(-x(3)*(eta-x(2)).^x(4));
% figure(9)
% clf
% % warning off all;
% semilogy(bar_lev,(CI_plus_reanch),'--k')
% hold on
% semilogy(bar_lev,(CI_minus_reanch),'--k')
% semilogy(bar_lev, acer_hat,'*k','MarkerSize',2)
% semilogy(BL_eps,(epsilon(BL_eps,fin_sol)),'k')
% semilogy(BL_CI_L,(epsilon(BL_CI_L, fin_sol_mn)),':k')
% semilogy(BL_CI_U,(epsilon(BL_CI_U,fin_sol_pl)),':k')
% semilogy(BL_CI_U,(level_of_interest)*ones(size(BL_CI_U)),':k')
% semilogy(x_eps_star,level_of_interest,'*k')
% legend('CI^{+}','CI^{-}','\epsilon_k(\eta)','\epsilon_k^{fit}','CI^{+}_{extr}','CI^{-}_{extr}')
% box on
% axis tight
%%
figure(999)
% subplot(2,1,1)
semilogy(lambda_v,pf_lambda,'-.','Marker','.','MarkerSize',10)
hold on
semilogy(L,pf1,'-k','Linewidth',0.5)
hold on
semilogy(lambda_v,pfX0,'--g','Linewidth',1)
hold on
semilogy(lambda_v,CI_p_lambda,'-- k')
hold on
semilogy(lambda_v,CI_m_lambda,'-- k')
hold on
semilogy(lambda_v,CI_p_lambda_reanch,'-- m')
hold on
semilogy(lambda_v,CI_m_lambda_reanch,'-- m')
hold on
semilogy(L,CI_m_lambda_reanch_m,'-- r')
hold on
semilogy(L,CI_p_lambda_reanch_p,'-- r')
hold on, x=x1:0.01:1; plot(x,pf1_L1.*ones(1,length(x)),'-.','Linewidth',1.0)
xlim([x1 1])
ylim([1e-11 0.2])
xlabel('\lambda')
ylabel('P_{f}(\lambda)')
hold off


Pf_brudd=[CI_m_lambda_reanch_L1_m,pf1_L1,CI_p_lambda_reanch_L1_p]
B_brudd=[abs(norminv(CI_m_lambda_reanch_L1_m)),abs(norminv(pf1_L1)),abs(norminv(CI_p_lambda_reanch_L1_p))]
DeltaB=B_brudd(1)-B_brudd(3)
pf0
pf1_L1
X
B_brudd
Pf_brudd_E7=Pf_brudd*1E7
% B=abs(norminv(pf0));
% pf2=1./sqrt(2.*pi).*(1./(L.*B)-1./(L.*B).^3+3./(L.*B).^5).*exp(-B.^2.*L.^2/2);
% semilogy(L,pf2,'-r')

%%
%% ------------------------------------------------- %
% % ---                             --- %
% % -------------------------------------------------- %
% CI_plus_reanch = acer_hat_fit + CI;
% CI_minus_reanch = acer_hat_fit - CI;
% % % CI_minus_reanch(CI_minus_reanch<0)=min(CI_minus_reanch(CI_minus_reanch>0));
% 
% condition = (CI_minus_reanch > 0); %& (CI_plus_reanch > 0);
% condition = updatecond(condition);
% CI_minus_reanch = CI_minus_reanch(condition);
% CI_plus_reanch = CI_plus_reanch(condition);
% bar_lev = bar_lev(condition);
% W = W(condition);
% acer_hat = acer_hat(condition);
% acer_hat_fit = acer_hat_fit(condition);
% CI_plus = CI_plus(condition);
% CI_minus = CI_minus(condition);
% clear condition;






% F = @(x) sum(W.*((log(ACER)-log(qMed)+...
%     x(2)*(eta - x(1)).^x(3))).^2); % x = [b a c]
% 
% nlnineq = @(x) [log(qMed) - x(2).*(eta - x(1)).^x(3)];
% nlneq = @(x) [];
% nonlinfcn = @(x)deal(nlnineq(x),nlneq(x));
% 
% optst_logGlobal = optimset('Display','off',...
%     'Algorithm', 'interior-point', ...
%     'MaxFunEvals', 10000, 'MaxIter', 10000,...
%     'TolX', 1e-12, 'TolFun', 1e-12);
% [sol(7,2:4), sol(7,5)] = fmincon(F,[b0 a0 c0],[],[],[],[],...
%     [bmin eps eps],...
%     [eta_1 Inf 5-eps],...
%     nonlinfcn,optst_logGlobal);























