function [omegaomega,phiphi,xred,MM,CC,KK,moderInt,Eigenvectors,Eigenvalues,L]=Import_Abaqus_v2(M, VALG)
%% Import Abaqus data
[Eigenvectors,Eigenvalues]=read_ABAQUS_dat('InputBugge.dat');
%% Still air properties
omegaomega=diag(Eigenvalues(VALG,3));
MM=diag(Eigenvalues(VALG,5));
zetazeta=0.005*diag(ones(1,size(omegaomega,1)));
% Definerer moden.
Koordinater=Eigenvectors(:,2:4);
[~, b]=sort(Koordinater(:,1));
Koordinater=Koordinater(b,:);
L=Koordinater(size(Koordinater,1))-Koordinater(1,1);
x=linspace(0,1,M)*L;
xred=linspace(0,1,M);
xg=Koordinater(:,1)-min(Koordinater(:,1));
phiphi=zeros(3,M,length(VALG));
teller=1;
for n=VALG
    phiphi(1,:,teller)=interp1(xg,Eigenvectors(b,6,n)',x);
    phiphi(2,:,teller)=interp1(xg,Eigenvectors(b,7,n)',x);
    phiphi(3,:,teller)=-interp1(xg,Eigenvectors(b,8,n)',x);
    teller=teller+1;
end
% omegaomega(4,4)=2.23 Test for  se om lik frekvens gir likt resultat som
% omegaomega(3,3)=2.23 ALVSAT. Vellykket!
CC=2*MM.*omegaomega.*zetazeta;
KK=omegaomega.^2.*MM;

for i=1:size(phiphi,3)
    for j=1:size(phiphi,3)
        for n=1:3
            for m=1:3
                integrand=phiphi(n,:,i).*phiphi(m,:,j);
                moderInt(n,m,i,j)=trapz(integrand)*1/(M-1)*L;                    
            end
        end       
    end
end


%%
function [Eigenvectors,Eigenvalues]=read_ABAQUS_dat(abaqfile)
% Description
% This routine is used to read the *.dat result file generated by ABAQUS
% 22.9.2010 Ole Andre iseth
fr = fopen(abaqfile);           
c = 1;
start_egenverdier=inf;
stop_egenverdier=0;
start_egenvektorer=inf;
stop_egenvektorer=0;
Eigenvalues=[];
teller=1;
teller_ev=1;
teller_n_evec=0;
N_nodes=657;
while(1)    
     tline = fgetl(fr);     
     if ~ischar(tline), break, end
     indikator2=strfind(tline,'NUMBER OF EIGENVALUES');     
     if isempty(indikator2)
     else
         N_eigenvalues=str2num(tline(47:49));
     end
     if strcmp('E I G E N V A L U E    O U T P U T',strtrim(tline))
         start_egenverdier=c+6;
         stop_egenverdier=c+6+N_eigenvalues;
         Eigenvalues=zeros(N_eigenvalues,6);
         Eigenvectors=zeros(N_nodes,10,N_eigenvalues);
     end     
     if c>=start_egenverdier && c<stop_egenverdier
         Eigenvalues(teller_ev,:)=str2num(tline);   
         teller_ev=teller_ev+1;
     end     
     if strcmp(strtrim(strtok(tline,'R')),'E I G E N V A L U E    N U M B E')
         start_egenvektorer=c+15;
         stop_egenvektorer=c+15+N_nodes;
         teller_n_evec=teller_n_evec+1;
         teller_linje_evec=1;         
     end
     if c>=start_egenvektorer && c<stop_egenvektorer
         Eigenvectors(teller_linje_evec,:,teller_n_evec)=str2num(tline);   
         teller_linje_evec=teller_linje_evec+1;
     end
     c = c+1;     
end
fclose(fr);


