function [plottV,plotfrekvenser,plotdemp,VCR,OmegaCR]=aerostab(fhandle,MM,CC,KK,omegaomega,I,ro,B,maxfit,maxVit,maxV,V,dV,RAD)
VCR=NaN;
OmegaCR=NaN;
first_n=4;
last_n=200;
last_n=min([last_n,size(MM,1)]);
antfit=0;
stopfit=0;
antVit=0;
stopVit=0;
pos=1;
ResMat=zeros(2,2*size(MM,1));
plottV=zeros(1,maxVit);
plotfrekvenser=zeros(2*size(MM,1),maxVit);
plotdemp=zeros(2*size(MM,1),maxVit);

%% Beregning av stabilitetsgrensen
while antVit<maxVit && stopVit==0 && V<maxV
    %% Iterasjon p frekvenser
    v=first_n-1;
    while v<last_n
        v=v+1;
        omegacr=omegaomega(v,1);
        while antfit<maxfit&&stopfit==0
            [KaeKae,CaeCae]=Self_exited_load2010(fhandle,V,MM,omegacr,I,ro,B,RAD);
            KKT=KK-KaeKae;CCT=CC-CaeCae;
            [~,e]=polyeig(KKT,CCT,MM);
            [sortertefrek, posid]=sort(imag(e),'ascend');
            sortertefrek=sortertefrek(size(posid,1)/2+1:size(posid,1));
            domega=omegacr-sortertefrek(v,1);
            omegacr=sortertefrek(v,1);
            if abs(domega)<0.0001
                stopfit=1;

            elseif omegacr<=0
            stopfit=1;
            end
            antfit=antfit+1;
           if antfit==maxfit
               beep
               '****************************************'
               'Frekvensiterasjonen har ikke konvergert'
               '****************************************'
               stopVit=1;
               stopfit=1;
           end
        end
        stopfit=0;antfit=0;
        posres=find(omegacr==abs(imag(e)));
        if size(posres,1)>2
            ResMat(1,2*v-1:2*v-1+size(posres,1)-1)=imag(e(posres));
            ResMat(2,2*v-1:2*v-1+size(posres,1)-1)=real(e(posres));
            v=v+size(posres,1)/2-1;
        else
            ResMat(1,2*v-1:2*v)=imag(e(posres));
            ResMat(2,2*v-1:2*v)=real(e(posres));
        end
    end    
%% Oppsamling av data
    [stabind pos_stabind]=max(ResMat(2,:));
    antVit=antVit+1;
    if stabind>0 && ne(ResMat(1,pos_stabind),0)
        V=V-0.5*dV;
        dV=0.5*dV;
    else
        plottV(1,pos)=V;
        plotfrekvenser(:,pos)=ResMat(1,:)';
        plotdemp(:,pos)=ResMat(2,:)';
        pos=pos+1;
        V=V+dV;
    end
%     if abs(stabind)<0.01 && dV<0.05
        if abs(stabind)<0.000001 && dV<0.0005
       stopVit=1;
       [Demping, posCR]=max(ResMat(2,:));
       OmegaCR=ResMat(1,posCR);
       VCR=V;
    end
    ResMat=zeros(2,2*size(MM,1));
    plottV=nonzeros(plottV)';
    plotfrekvenser=plotfrekvenser(:,1:size(plottV,2));
    plotdemp=plotdemp(:,1:size(plottV,2));
%     figure(100)
%     subplot(2,1,1)
%     plot(plottV,plotfrekvenser')
%     ylim([0 3])
%     title(['V=' num2str(plottV(1,pos-1)) ])
%      subplot(2,1,2)
%     plot(plottV,plotdemp')
%     ylim([-0.5 0])
%     waitforbuttonpress
    
end
plottV=nonzeros(plottV);
plotfrekvenser=plotfrekvenser(:,1:size(plottV,1));
plotdemp=plotdemp(:,1:size(plottV,1));






function [KaeKae,CaeCae]=Self_exited_load2010(fhandle,V,MM,omegacr,I,ro,B,RAD)
% Initielle beregninger
if omegacr==0
    omegacr=1.0e-20;
end
vhatt=V/(B*omegacr);
aerovektor=fhandle(vhatt,RAD);
kaekaeorg=(omegacr)^2*ro*B^2/2*[aerovektor(4,1) aerovektor(6,1) B*aerovektor(3,1);aerovektor(12,1) aerovektor(10,1) B*aerovektor(9,1);B*aerovektor(18,1) B*aerovektor(16,1) B^2*aerovektor(15,1)];
caecaeorg=omegacr*ro*B^2/2*[aerovektor(1,1) aerovektor(5,1) B*aerovektor(2,1);aerovektor(11,1) aerovektor(7,1) B*aerovektor(8,1); B*aerovektor(17,1) B*aerovektor(13,1) B^2*aerovektor(14,1)];
KaeKae=zeros(size(MM,1),size(MM,1));
CaeCae=zeros(size(MM,1),size(MM,1));
for i=1:size(MM,1)
    for j=1:size(MM,1)
        KaeKae(i,j)=sum(sum(I(:,:,i,j).*kaekaeorg));
        CaeCae(i,j)=sum(sum(I(:,:,i,j).*caecaeorg));
    end
end
