clc
clear all
close all
%% Import data
[Vred AD]=ImportAD();
posAD=[1 5 2   11 7 8  17 13 14;   4 6 3    12 10 9   18 16 15];
label={'P_1' 'P_2' 'P_3' 'P_4' 'P_5' 'P_6' 'H1' 'H2' 'H3' 'H4' 'H5' 'H6' 'A_1' 'A_2' 'A_3' 'A_4' 'A_5' 'A_6'   };

%%
for j=1:size(AD,2)
    tmp=zeros(size(AD,1),3*size(AD,1));
    for n=1:size(AD,1)
       tmp(n,n)=1;
       tmp(n,n+size(AD,1))=Vred(n,j);
       tmp(n,n+2*size(AD,1))=Vred(n,j)^2;
    end        
        X{j,1} = tmp;
end
[beta,sig,resid,vars,loglik2] = mvregress(X,AD');
B = [beta(1:size(AD,1))';beta(size(AD,1)+1:2*size(AD,1))'; beta(2*size(AD,1)+1:end)'];

VredP=linspace(0,5,100);
ADfit=[ones(size(VredP))',VredP', VredP'.^2]*B;


% save('Stat.mat','beta','vars')

%%

%% Realizations
for n=1:100
    BETA=mvnrnd(beta,vars,1)';
    Br = [BETA(1:size(AD,1))';BETA(size(AD,1)+1:2*size(AD,1))'; BETA(2*size(AD,1)+1:end)'];
    ADfitr=[ones(size(VredP))',VredP', VredP'.^2]*Br;

    figure(1)
    for n=1:9
        subplot(3,3,n)
        hold on
        plot(VredP,ADfitr(:,posAD(1,n)),'Color',[0.8 0.8 0.8])
    end
    

    figure(2)
    hold on
    for n=1:9
        subplot(3,3,n)
        hold on
        plot(VredP,ADfitr(:,posAD(2,n)),'Color',[0.8 0.8 0.8])
    end
end
%% Plot data and fit
figure(1)
for n=1:9
    subplot(3,3,n)
    hold on
    plot(Vred(posAD(1,n),:),AD(posAD(1,n),:),'o r','MarkerFaceColor','r')
    plot(VredP,ADfit(:,posAD(1,n)),'--k')
    ylabel(label{1,posAD(1,n)})
    title(num2str(n))
    xlim([min(Vred(posAD(1,n),:)) max(Vred(posAD(1,n),:))])
end
figure(2)
hold on
for n=1:9
    subplot(3,3,n)
    hold on
    plot(Vred(posAD(2,n),:),AD(posAD(2,n),:),'o r','MarkerFaceColor','r')
    plot(VredP,ADfit(:,posAD(2,n)),'--k')
    ylabel(label{1,posAD(2,n)})
    title(num2str(n))
    xlim([min(Vred(posAD(1,n),:)) max(Vred(posAD(1,n),:))])
end